//--------------------------------------------------------------------------------------
// File: GrantsdaleHDR.cpp
//--------------------------------------------------------------------------------------
#include "dxstdafx.h"
#include "resource.h"
#include "skybox.h"
#include "stdafx.h"
#include "SIMD.h"
#include <stdlib.h>
#include <stdio.h>

//#define DEBUG_VS   // Uncomment this line to debug vertex shaders 
//#define DEBUG_PS   // Uncomment this line to debug pixel shaders 

#define BALL_SPEED 3
char g_strHDRDirectory[512] = "Media\\";
char g_strHDRFilename[512] = "stpeters_cross.hdr";

#define NUM_BLOOM_TEXTURES    2

enum RENDER_MODE { DECODED, RGB_ENCODED, ALPHA_ENCODED, NUM_RENDER_MODES };
enum CAMERA_MODE { MOVING, STATIONARY, NUM_CAMERA_MODES };

const WCHAR* RENDER_MODE_NAMES[] =
{
    L"Decoded scene",
    L"RGB channels of encoded textures",
    L"Alpha channel of encoded textures",
};

const WCHAR* CAMERA_MODE_NAMES[] =
{
    L"Rotating camera",
    L"Stationary camera",
};

struct TECH_HANDLES
{
    D3DXHANDLE Scene;
    D3DXHANDLE DownScale3x3;
    D3DXHANDLE DownScale3x3_BrightPass;
    D3DXHANDLE FinalPass;
};

struct SCREEN_VERTEX 
{
    D3DXVECTOR4 pos;
    D3DXVECTOR2 tex;

    static const DWORD FVF;
};
const DWORD SCREEN_VERTEX::FVF = D3DFVF_XYZRHW | D3DFVF_TEX1;


IDirect3DDevice9*       g_pd3dDevice;         
ID3DXFont*              g_pFont;              
CModelViewerCamera      g_Camera;      
LPD3DXEFFECT            g_pEffect;
CDXUTDialog             g_HUD;             
CDXUTDialog             g_SampleUI;        
CSkybox                 g_Skybox;   
LPDIRECT3DTEXTURE9      g_pTexCross_RGBE8;    
LPDIRECT3DTEXTURE9      g_pTexRender;         
LPDIRECT3DTEXTURE9      g_pTexBrightPass;     
LPDIRECT3DSURFACE9      g_pLumSurf;         
LPD3DXMESH              g_pMesh0;
LPD3DXMESH              g_pMesh1;
LPD3DXMESH              g_pMesh2;
LPD3DXMESH              g_pMesh3;
BOOL					g_CameraHasMoved;
LPDIRECT3DTEXTURE9      g_apTexBloom[NUM_BLOOM_TEXTURES];     
RENDER_MODE             g_eRenderMode;
CAMERA_MODE				g_eCameraMode;
TECH_HANDLES            g_aTechHandles;
TECH_HANDLES*           g_pCurTechnique;
bool                    g_bBloom;             
bool                    g_bShowHelp;
bool                    g_bShowText;
bool					g_bUseSIMD = 0;
int						g_iMiddleGray = 144;
float					g_fMiddleGray = 1.44;
double					g_lastupdate = 0;
double					g_dRGBELoadtime;	
wchar_t					g_strLoadtime[255];
wchar_t					g_strLumCalctime[255];

//global variables
bool				g_bSIMDConvert;
double				g_dLumCalcTime;
float				g_fCurrentImageKey = 0;
bool				g_firstrun = 1;
float				g_fPreviousImageKey = 0;
float				g_fImageKey;

extern __int64				g_start, g_stop;
extern __int64				g_speed;


//--------------------------------------------------------------------------------------
// UI control IDs
//--------------------------------------------------------------------------------------
#define IDC_STATIC						-1
#define IDC_TOGGLEFULLSCREEN			1
#define IDC_TOGGLEREF					2
#define IDC_CHANGEDEVICE				3
#define IDC_RENDER_MODE					4
#define IDC_BLOOM						5
#define IDC_CAMERA_MODE					6
#define IDC_MIDDLE_GRAY					7
#define IDC_CHANGE_MIDDLE_GRAY_STATIC	8
#define IDC_USESIMD						9



//--------------------------------------------------------------------------------------
// Forward declarations 
//--------------------------------------------------------------------------------------
bool    CALLBACK IsDeviceAcceptable( D3DCAPS9* pCaps, D3DFORMAT AdapterFormat, D3DFORMAT BackBufferFormat, bool bWindowed );
void    CALLBACK ModifyDeviceSettings( DXUTDeviceSettings* pDeviceSettings, const D3DCAPS9* pCaps );
HRESULT CALLBACK OnCreateDevice( IDirect3DDevice9* pd3dDevice, const D3DSURFACE_DESC* pBackBufferSurfaceDesc );
HRESULT CALLBACK OnResetDevice( IDirect3DDevice9* pd3dDevice, const D3DSURFACE_DESC* pBackBufferSurfaceDesc );
void    CALLBACK OnFrameMove( IDirect3DDevice9* pd3dDevice, double fTime, float fElapsedTime );
void    CALLBACK OnFrameRender( IDirect3DDevice9* pd3dDevice, double fTime, float fElapsedTime );
LRESULT CALLBACK MsgProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam, bool* pbNoFurtherProcessing );
void    CALLBACK KeyboardProc( UINT nChar, bool bKeyDown, bool bAltDown  );
void    CALLBACK OnGUIEvent( UINT nEvent, int nControlID, CDXUTControl* pControl );
void    CALLBACK OnLostDevice();
void    CALLBACK OnDestroyDevice();

void    InitApp();
HRESULT LoadMeshes( IDirect3DDevice9* pd3dDevice, ID3DXMesh** ppMesh0, ID3DXMesh** ppMesh1, ID3DXMesh** ppMesh2, ID3DXMesh** ppMesh3 );
void    RenderText( double fTime, double fElapsedTime );
void    DrawFullScreenQuad(float fLeftU=0.0f, float fTopV=0.0f, float fRightU=1.0f, float fBottomV=1.0f);
HRESULT RenderModels( double fTime );
HRESULT RenderSkybox();
HRESULT RetrieveTechHandles();
HRESULT GetSampleOffsets_DownScale3x3( DWORD dwWidth, DWORD dwHeight, D3DXVECTOR2 avSampleOffsets[] );
HRESULT GetSampleOffsets_Bloom( DWORD dwD3DTexSize, float afTexCoordOffset[15], D3DXVECTOR4* avColorWeight, float fDeviation, float fMultiplier=1.0f );
HRESULT RenderBloom();
HRESULT MeasureLuminance(IDirect3DDevice9* pd3dDevice, LPDIRECT3DSURFACE9 pSourceRenderTarget, LPDIRECT3DSURFACE9 g_pLumSurf, bool g_bUseSIMD);
HRESULT BrightPassFilter();
//HRESULT CreateRGBETextureFromRLEFile( IDirect3DDevice9* pd3dDevice, LPDIRECT3DTEXTURE9* ppTexDest_RGBE8, char* strHDRFile );


//--------------------------------------------------------------------------------------
// WinMain
//--------------------------------------------------------------------------------------
INT WINAPI WinMain( HINSTANCE, HINSTANCE, LPSTR tempstr, int argcount )
{
    DXUTSetCallbackDeviceCreated( OnCreateDevice );
    DXUTSetCallbackDeviceReset( OnResetDevice );
    DXUTSetCallbackDeviceLost( OnLostDevice );
    DXUTSetCallbackDeviceDestroyed( OnDestroyDevice );
    DXUTSetCallbackMsgProc( MsgProc );
    DXUTSetCallbackKeyboard( KeyboardProc );
    DXUTSetCallbackFrameRender( OnFrameRender );
    DXUTSetCallbackFrameMove( OnFrameMove );

	const char* g_strHDRFilename2 = tempstr;

	if(strlen(tempstr) > 1 )
		strcpy( g_strHDRFilename, g_strHDRFilename2);
	

    // Show the cursor and clip it when in full screen
    DXUTSetCursorSettings( true, true );

    InitApp();

    DXUTInit( true, true, true );	// Parse the command line, handle the default hotkeys, and show msgboxes
    DXUTCreateWindow( L"GrantsdaleHDR" );
    DXUTCreateDevice( D3DADAPTER_DEFAULT, true, 640, 480, IsDeviceAcceptable, ModifyDeviceSettings );

    DXUTMainLoop();

    return DXUTGetExitCode();
}


//--------------------------------------------------------------------------------------
// InitApp 
//--------------------------------------------------------------------------------------
void InitApp()
{

	g_pFont = NULL;
    g_pEffect = NULL;
    g_bShowHelp = false;
    g_bShowText = true;

    g_pMesh0 = NULL;
	g_pMesh1 = NULL;
	g_pMesh2 = NULL;
	g_pMesh3 = NULL;
    g_pTexRender = NULL;
	g_pLumSurf = NULL;

	g_pTexCross_RGBE8 = NULL;

	g_bBloom = TRUE;
    g_eRenderMode = DECODED;
	g_eCameraMode = MOVING;
    
    g_pCurTechnique = &g_aTechHandles;

    ZeroMemory( g_apTexBloom, sizeof(g_apTexBloom) );
    ZeroMemory( &g_aTechHandles, sizeof(g_aTechHandles) );

    g_HUD.SetFont( 0, L"Arial", 14, 400 );
    g_HUD.SetCallback( OnGUIEvent );

    // Initialize dialogs
    g_HUD.SetCallback( OnGUIEvent ); int iY = 10; 
    g_HUD.AddButton( IDC_TOGGLEFULLSCREEN, L"Toggle full screen", 35, iY, 125, 22 );
    g_HUD.AddButton( IDC_TOGGLEREF, L"Toggle REF (F3)", 35, iY += 24, 125, 22 );
    g_HUD.AddButton( IDC_CHANGEDEVICE, L"Change device (F2)", 35, iY += 24, 125, 22 );
	
    g_SampleUI.SetCallback( OnGUIEvent ); iY = 10; 

	CDXUTComboBox* pComboBox1 = NULL;
	CDXUTComboBox* pComboBox2 = NULL;

	g_SampleUI.AddStatic( IDC_STATIC, L"(R)ender mode", 0, 45, 105, 25 );
    g_SampleUI.AddComboBox( IDC_RENDER_MODE, 0, 70, 140, 24, 'R', false, &pComboBox1 );

    pComboBox1->SetDropHeight( 30 );
    
    for( int i=0; i < NUM_RENDER_MODES; i++ )
    {
        pComboBox1->AddItem( RENDER_MODE_NAMES[i], IntToPtr(i) );
    }

	g_SampleUI.AddStatic( IDC_STATIC, L"(C)amera mode", 0, 95 , 105, 25 );
    g_SampleUI.AddComboBox( IDC_CAMERA_MODE, 0, 120, 140, 24, 'C', false, &pComboBox2 );

    pComboBox2->SetDropHeight( 30 );
    
    for( int i=0; i < NUM_CAMERA_MODES; i++ )
    {
        pComboBox2->AddItem( CAMERA_MODE_NAMES[i], IntToPtr(i) );
    }

    g_SampleUI.AddCheckBox( IDC_BLOOM, L"Show (B)loom", 0, 150, 140, 18, g_bBloom, 'B' );

	WCHAR sz[100];
    _snwprintf( sz, 100, L"Middle Gray: %2.2f", g_fMiddleGray ); 
	sz[99] = 0;
    g_SampleUI.AddStatic( IDC_CHANGE_MIDDLE_GRAY_STATIC, sz, 0, 170, 125, 22 );
	g_SampleUI.AddSlider( IDC_MIDDLE_GRAY, 0, 195, 200, 18, 0, 1000, g_iMiddleGray );

	g_SampleUI.AddCheckBox( IDC_USESIMD, L"Use (S)IMD Luminance", 0, 225, 150, 20, false, L'S', false );


}


//--------------------------------------------------------------------------------------
// IsDeviceAcceptable
//--------------------------------------------------------------------------------------
bool CALLBACK IsDeviceAcceptable( D3DCAPS9* pCaps, D3DFORMAT AdapterFormat, 
                                  D3DFORMAT BackBufferFormat, bool bWindowed )
{	
	// Skip backbuffer formats that don't support alpha blending
    IDirect3D9* pD3D = DXUTGetD3DObject(); 
    if( FAILED( pD3D->CheckDeviceFormat( pCaps->AdapterOrdinal, pCaps->DeviceType,
                    AdapterFormat, D3DUSAGE_QUERY_POSTPIXELSHADER_BLENDING, 
                    D3DRTYPE_TEXTURE, BackBufferFormat ) ) )
        return false;

    return true;
}


//--------------------------------------------------------------------------------------
// ModifyDeviceSettings
//--------------------------------------------------------------------------------------
void CALLBACK ModifyDeviceSettings( DXUTDeviceSettings* pDeviceSettings, const D3DCAPS9* pCaps )
{
    // If device doesn't support HW T&L or doesn't support 1.1 vertex shaders in HW 
    // then switch to SWVP.
    if( (pCaps->DevCaps & D3DDEVCAPS_HWTRANSFORMANDLIGHT) == 0 ||
         pCaps->VertexShaderVersion < D3DVS_VERSION(1,1) )
    {
        pDeviceSettings->BehaviorFlags = D3DCREATE_SOFTWARE_VERTEXPROCESSING;
    }
    else
    {
        pDeviceSettings->BehaviorFlags = D3DCREATE_HARDWARE_VERTEXPROCESSING;
    }

    // This application is designed to work on a pure device by not using 
    // IDirect3D9::Get*() methods, so create a pure device if supported and using HWVP.
    if ((pCaps->DevCaps & D3DDEVCAPS_PUREDEVICE) != 0 && 
        (pDeviceSettings->BehaviorFlags & D3DCREATE_HARDWARE_VERTEXPROCESSING) != 0 )
        pDeviceSettings->BehaviorFlags |= D3DCREATE_PUREDEVICE;

    // Debugging vertex shaders requires either REF or software vertex processing 
    // and debugging pixel shaders requires REF.  
#ifdef DEBUG_VS
    if( pDeviceSettings->DeviceType != D3DDEVTYPE_REF )
    {
        pDeviceSettings->BehaviorFlags &= ~D3DCREATE_HARDWARE_VERTEXPROCESSING;
        pDeviceSettings->BehaviorFlags &= ~D3DCREATE_PUREDEVICE;
        pDeviceSettings->BehaviorFlags |= D3DCREATE_SOFTWARE_VERTEXPROCESSING;
    }
#endif
#ifdef DEBUG_PS
    pDeviceSettings->DeviceType = D3DDEVTYPE_REF;
#endif
}


//--------------------------------------------------------------------------------------
// OnCreateDevice
//--------------------------------------------------------------------------------------
HRESULT CALLBACK OnCreateDevice( IDirect3DDevice9* pd3dDevice, const D3DSURFACE_DESC* pBackBufferSurfaceDesc )
{
    HRESULT hr;

	//Use correct method for determining Intel graphics features
	//Do use:		IDirect3DDevice9::GetDeviceCaps()
	//Don't use:	IDirect3D9::GetDeviceCaps()
	D3DCAPS9 GDGcaps;
    IDirect3DDevice9* pD3DDevice = DXUTGetD3DDevice();
    pD3DDevice->GetDeviceCaps( &GDGcaps );
	
	//Requires PS 2.0 (supported on Grantsdale)
	if( GDGcaps.PixelShaderVersion < D3DPS_VERSION(2,0) )
        return false;

	// Initialize the font
    V_RETURN( D3DXCreateFont( pd3dDevice, 15, 0, FW_BOLD, 1, FALSE, DEFAULT_CHARSET, 
                         OUT_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, 
                         L"Arial", &g_pFont ) );

    DWORD dwShaderFlags = 0;
    #ifdef DEBUG_VS
        dwShaderFlags |= D3DXSHADER_FORCE_VS_SOFTWARE_NOOPT;
		dwShaderFlags |= D3DXSHADER_DEBUG;
		dwShaderFlags |= D3DXSHADER_SKIPOPTIMIZATION;
    #endif
    #ifdef DEBUG_PS
        dwShaderFlags |= D3DXSHADER_FORCE_PS_SOFTWARE_NOOPT;
		dwShaderFlags |= D3DXSHADER_DEBUG;
		dwShaderFlags |= D3DXSHADER_SKIPOPTIMIZATION;
    #endif

	g_pd3dDevice = pd3dDevice;

	//Initialize our skybox
	g_Skybox.Create( pd3dDevice, 50 );
    g_Skybox.InitDeviceObjects();

    // Read the D3DX effect file
    WCHAR str[MAX_PATH];
    V_RETURN( DXUTFindDXSDKMediaFileCch( str, MAX_PATH, L"GrantsdaleHDR.fx" ) );

    // If this fails, there should be debug output as to 
    // they the .fx file failed to compile
    V_RETURN( D3DXCreateEffectFromFile( pd3dDevice, str, NULL, NULL, dwShaderFlags, NULL, &g_pEffect, NULL ) );

	bool bCreatedTexture = false;
    IDirect3DCubeTexture9* pCubeTexture = NULL;
    IDirect3DCubeTexture9* pEncodedTexture = NULL;

	
	RetrieveTechHandles();

	CTimer myTimer;
	__int64 speed, start, stop;
	speed = myTimer.GetCPUSpeed();

	//build filepath
	char* strHDRFile = strcat( g_strHDRDirectory, g_strHDRFilename );

	start = myTimer.GetTime();
		V_RETURN( CreateRGBETextureFromRLEFile( pd3dDevice, &g_pTexCross_RGBE8, strHDRFile  ) ); 
	stop = myTimer.GetTime();

	g_dRGBELoadtime = (double)stop - (double)start;

	swprintf( g_strLoadtime, L"Time required for CreateRGBETextureFromRLEFile: %10.3f sec ", g_dRGBELoadtime/1000000 );

	V_RETURN( LoadMeshes( pd3dDevice, &g_pMesh0, &g_pMesh1, &g_pMesh2, &g_pMesh3 ) );
    
	// Setup the camera
    float fAspectRatio = pBackBufferSurfaceDesc->Width / (FLOAT)pBackBufferSurfaceDesc->Height;
    g_Camera.SetProjParams( D3DX_PI/4, fAspectRatio, 1.0f, 100.0f );

    // Setup the camera's view parameters
    D3DXVECTOR3 vecEye(0.0f, 0.0f, -5.0f);
    D3DXVECTOR3 vecAt (0.0f, 0.0f, -0.0f);
    g_Camera.SetViewParams( &vecEye, &vecAt );

    return S_OK;
}


//--------------------------------------------------------------------------------------
// LoadMeshes
//--------------------------------------------------------------------------------------
HRESULT LoadMeshes( IDirect3DDevice9* pd3dDevice, ID3DXMesh** ppMesh0, ID3DXMesh** ppMesh1, ID3DXMesh** ppMesh2, ID3DXMesh** ppMesh3 )
{
    ID3DXMesh* pMesh0 = NULL;
	ID3DXMesh* pMesh1 = NULL;
	ID3DXMesh* pMesh2 = NULL;
	ID3DXMesh* pMesh3 = NULL;

    HRESULT hr;

	V_RETURN( D3DXCreateSphere( pd3dDevice, 0.4, 24, 24, &pMesh0, NULL) );
	V_RETURN( D3DXCreateSphere( pd3dDevice, 0.4, 24, 24, &pMesh1, NULL) );
	V_RETURN( D3DXCreateSphere( pd3dDevice, 0.4, 24, 24, &pMesh2, NULL) );
	V_RETURN( D3DXCreateSphere( pd3dDevice, 0.4, 24, 24, &pMesh3, NULL) );

	*ppMesh0 = pMesh0;
	*ppMesh1 = pMesh1;
	*ppMesh2 = pMesh2;
	*ppMesh3 = pMesh3;

    return S_OK;
}


//--------------------------------------------------------------------------------------
// OnResetDevice
//--------------------------------------------------------------------------------------
HRESULT CALLBACK OnResetDevice( IDirect3DDevice9* pd3dDevice, 
                                const D3DSURFACE_DESC* pBackBufferSurfaceDesc )
{
    HRESULT hr;

	if( pd3dDevice == NULL )
        return S_OK;

    g_Skybox.RestoreDeviceObjects();

    if( g_pFont )
        V_RETURN( g_pFont->OnResetDevice() );
    if( g_pEffect )
        V_RETURN( g_pEffect->OnResetDevice() );

	V_RETURN( pd3dDevice->CreateTexture( pBackBufferSurfaceDesc->Width, pBackBufferSurfaceDesc->Height, 
                                      1, D3DUSAGE_RENDERTARGET, D3DFMT_A8R8G8B8, 
                                      D3DPOOL_DEFAULT, &g_pTexRender, NULL ) );

	V_RETURN( pd3dDevice->CreateTexture( pBackBufferSurfaceDesc->Width/8, pBackBufferSurfaceDesc->Height/8, 
                                      1, D3DUSAGE_RENDERTARGET, D3DFMT_A8R8G8B8, 
                                      D3DPOOL_DEFAULT, &g_pTexBrightPass, NULL ) );


	//Create off screen surface for luminance calculations
	V_RETURN( pd3dDevice->CreateOffscreenPlainSurface( pBackBufferSurfaceDesc->Width, pBackBufferSurfaceDesc->Height,
							D3DFMT_A8R8G8B8, D3DPOOL_SYSTEMMEM, &g_pLumSurf, NULL ) );


	// Create the temporary blooming effect textures
    for( int i=0; i < NUM_BLOOM_TEXTURES; i++ )
    {
        V_RETURN( pd3dDevice->CreateTexture( pBackBufferSurfaceDesc->Width/8, pBackBufferSurfaceDesc->Height/8,
                                        1, D3DUSAGE_RENDERTARGET, D3DFMT_A8R8G8B8, 
                                        D3DPOOL_DEFAULT, &g_apTexBloom[i], NULL) );
    }

	// Fill the skybox textures
    LPDIRECT3DTEXTURE9 pTexCross = g_pTexCross_RGBE8;

	V_RETURN( g_Skybox.CreateTexturesFromCross( pTexCross ) );

    CDXUTCheckBox* pCheckBox = g_SampleUI.GetCheckBox( IDC_BLOOM );
    pCheckBox->SetChecked( g_bBloom );

    CDXUTComboBox* pComboBox1 = g_SampleUI.GetComboBox( IDC_RENDER_MODE );
    pComboBox1->SetSelectedByData( (void*) g_eRenderMode );

	CDXUTComboBox* pComboBox2 = g_SampleUI.GetComboBox( IDC_CAMERA_MODE );
    pComboBox2->SetSelectedByData( (void*) g_eCameraMode );

	CDXUTSlider* pSlider1 = g_SampleUI.GetSlider( IDC_MIDDLE_GRAY );
	pSlider1->SetValue( g_iMiddleGray );

	CDXUTCheckBox* pCheckBox2 = g_SampleUI.GetCheckBox( IDC_USESIMD );
	pCheckBox2->SetChecked( g_bUseSIMD );

    // Setup the camera's projection parameters
    float fAspectRatio = pBackBufferSurfaceDesc->Width / (FLOAT)pBackBufferSurfaceDesc->Height;
    g_Camera.SetProjParams( D3DX_PI/4, fAspectRatio, 0.1f, 1000.0f );
    g_Camera.SetWindow( pBackBufferSurfaceDesc->Width, pBackBufferSurfaceDesc->Height );

    g_HUD.SetLocation( pBackBufferSurfaceDesc->Width-170, 0 );
    g_HUD.SetSize( 170, 170 );
    g_SampleUI.SetLocation( pBackBufferSurfaceDesc->Width-170, pBackBufferSurfaceDesc->Height-350 );
    g_SampleUI.SetSize( 170, 300 );

    return S_OK;
}


//--------------------------------------------------------------------------------------
// OnFrameMove
//--------------------------------------------------------------------------------------
void CALLBACK OnFrameMove( IDirect3DDevice9* pd3dDevice, double fTime, float fElapsedTime )
{
    UNREFERENCED_PARAMETER( pd3dDevice );

	D3DXVECTOR3 LookatPoint(0.0, 0.0, 0.0);
	D3DXVECTOR3 EyePoint;
	
	switch ( g_eCameraMode )
	{
		case ( MOVING ): 
			EyePoint.x = 5*sin((fTime-100)/15);
			EyePoint.y = 5*-sin((fTime-100)/15);
			EyePoint.z = 5*-cos((fTime-100)/15);
			g_Camera.SetViewParams( &EyePoint, &LookatPoint );
			g_CameraHasMoved = 1;
			break;
		case ( STATIONARY ):
			if( g_CameraHasMoved )
			{
				EyePoint.x = 0.0;
				EyePoint.y = 0.0;
				EyePoint.z = -5.0;
				g_Camera.SetViewParams( &EyePoint, &LookatPoint );
				g_CameraHasMoved = 0;
			}
			else
			{
				g_Camera.FrameMove( fElapsedTime );
			}
			break;
	}
	
    g_pEffect->SetValue( "g_vEyePt", g_Camera.GetEyePt(), sizeof(D3DXVECTOR3) );
}


//--------------------------------------------------------------------------------------
// OnFrameRender
//--------------------------------------------------------------------------------------
void CALLBACK OnFrameRender( IDirect3DDevice9* pd3dDevice, double fTime, float fElapsedTime )
{
    UNREFERENCED_PARAMETER( fElapsedTime );
    
    // Clear the render target
    pd3dDevice->Clear( 0L, NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER, 0x000000FF, 1.0f, 0L );

    LPDIRECT3DSURFACE9 pSurfBackBuffer = NULL;
    pd3dDevice->GetRenderTarget( 0, &pSurfBackBuffer );

    LPDIRECT3DSURFACE9 pSurfRenderTarget = NULL;
    g_pTexRender->GetSurfaceLevel( 0, &pSurfRenderTarget );

    pd3dDevice->SetRenderTarget( 0, pSurfRenderTarget );

    // For the first pass we'll draw the screen to the full screen render target
    // and to update the velocity render target with the velocity of each pixel 
	
    if( SUCCEEDED( pd3dDevice->BeginScene() ) )
    {
		RenderSkybox();
        RenderModels(fTime);
        MeasureLuminance(pd3dDevice, pSurfRenderTarget, g_pLumSurf, g_bUseSIMD);    
        BrightPassFilter();

        if( g_bBloom ) 
            RenderBloom();

        //---------------------------------------------------------------------
        // Final pass
        pd3dDevice->SetRenderTarget( 0, pSurfBackBuffer );
        pd3dDevice->SetTexture( 0, g_pTexRender );
        pd3dDevice->SetTexture( 1, g_bBloom ? g_apTexBloom[0] : NULL );

        pd3dDevice->SetSamplerState( 1, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR );
        pd3dDevice->SetSamplerState( 1, D3DSAMP_MINFILTER, D3DTEXF_LINEAR );        

		
        switch( g_eRenderMode )
        {
            case DECODED:       g_pEffect->SetTechnique( g_pCurTechnique->FinalPass ); break;
            case RGB_ENCODED:   g_pEffect->SetTechnique( "FinalPassEncoded_RGB" ); break;
            case ALPHA_ENCODED: g_pEffect->SetTechnique( "FinalPassEncoded_A" ); break;
        }
		
		g_pEffect->SetValue("g_fImageKey", &g_fImageKey, sizeof(FLOAT));
		g_pEffect->SetValue("g_fMiddleGray", &g_fMiddleGray, sizeof(float));
         
        UINT uiPass, uiNumPasses;
        g_pEffect->Begin( &uiNumPasses, 0 );

        for( uiPass=0; uiPass < uiNumPasses; uiPass++ )
        {
            g_pEffect->BeginPass( uiPass );
            
            DrawFullScreenQuad();

            g_pEffect->EndPass();
        }

        g_pEffect->End();
        pd3dDevice->SetTexture( 0, NULL );
        pd3dDevice->SetTexture( 1, NULL );
        pd3dDevice->SetTexture( 2, NULL );

        if( g_bShowText )
            RenderText( fTime, fElapsedTime );

        g_HUD.OnRender( fElapsedTime );
        g_SampleUI.OnRender( fElapsedTime );

        pd3dDevice->EndScene();
    }

    SAFE_RELEASE( pSurfRenderTarget );
    SAFE_RELEASE( pSurfBackBuffer );
}


//--------------------------------------------------------------------------------------
// RenderText
//--------------------------------------------------------------------------------------
void RenderText( double fTime, double fElapsedTime )
{
    // The helper object simply helps keep track of text position, and color
    // and then it calls pFont->DrawText( m_pSprite, strMsg, -1, &rc, DT_NOCLIP, m_clr );
    // If NULL is passed in as the sprite object, then it will work fine however the 
    // pFont->DrawText() will not be batched together.  Batching calls will improves perf.
    CDXUTTextHelper txtHelper( g_pFont, NULL, 15 );

    // Output statistics
    txtHelper.Begin();
    txtHelper.SetInsertionPos( 2, 0 );
    txtHelper.SetForegroundColor( D3DXCOLOR( 1.0f, 1.0f, 0.0f, 1.0f ) );
    txtHelper.DrawTextLine( DXUTGetFrameStats() );
    txtHelper.DrawTextLine( DXUTGetDeviceStats() );

    txtHelper.SetForegroundColor( D3DXCOLOR( 0.90f, 0.90f, 1.0f, 1.0f ) );
    txtHelper.DrawFormattedTextLine( RENDER_MODE_NAMES[ g_eRenderMode ] );
    
    // Draw help
    if( g_bShowHelp )
    {
        const D3DSURFACE_DESC* pd3dsdBackBuffer = DXUTGetBackBufferSurfaceDesc();
        txtHelper.SetInsertionPos( 2, pd3dsdBackBuffer->Height-15*6 );
        txtHelper.SetForegroundColor( D3DXCOLOR( 1.0f, 0.75f, 0.0f, 1.0f ) );
        txtHelper.DrawTextLine( L"Controls:" );

        txtHelper.SetInsertionPos( 20, pd3dsdBackBuffer->Height-15*5 );
        txtHelper.DrawTextLine( L"Rotate model: Left mouse button\n"
                                L"Rotate camera: Right mouse button\n"
                                L"Zoom camera: Mouse wheel scroll\n"
                                L"Quit: ESC" );

        txtHelper.SetInsertionPos( 250, pd3dsdBackBuffer->Height-15*5 );
        txtHelper.DrawTextLine( L"Cycle encoding: E\n"
                                L"Cycle render mode: R\n" 
                                L"Toggle bloom: B\n"
                                L"Hide text: T\n" );

        txtHelper.SetInsertionPos( 410, pd3dsdBackBuffer->Height-15*5 );
        txtHelper.DrawTextLine( L"Hide help: F1\n"
                                L"Change Device: F2\n"
                                L"Toggle HAL/REF: F3\n"
                                L"View readme: F9\n" );
    }
    else
    {
        txtHelper.SetForegroundColor( D3DXCOLOR( 1.0f, 1.0f, 1.0f, 1.0f ) );
        txtHelper.DrawTextLine( L"Press F1 for help" );
    }

	
	if (g_lastupdate == 0)
		g_lastupdate = fTime;
	
	if( fTime - g_lastupdate > 1.0f)
    {
		g_lastupdate = fTime;
		swprintf( g_strLumCalctime, L"Time required for MeasureLuminance: %10.3f ms ", g_dLumCalcTime );
				
	}
	
	txtHelper.DrawTextLine( g_strLumCalctime );
	txtHelper.DrawTextLine( g_strLoadtime );

    txtHelper.End();
}


//--------------------------------------------------------------------------------------
// MsgProc
//--------------------------------------------------------------------------------------
LRESULT CALLBACK MsgProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam, bool* pbNoFurtherProcessing )
{
    // Give the dialogs a chance to handle the message first
    *pbNoFurtherProcessing = g_HUD.MsgProc( hWnd, uMsg, wParam, lParam );
    if( *pbNoFurtherProcessing )
        return 0;
    *pbNoFurtherProcessing = g_SampleUI.MsgProc( hWnd, uMsg, wParam, lParam );
    if( *pbNoFurtherProcessing )
        return 0;

    // Pass all remaining windows messages to camera so it can respond to user input
    g_Camera.HandleMessages( hWnd, uMsg, wParam, lParam );

    return 0;
}


//--------------------------------------------------------------------------------------
//  KeyboardProc
//--------------------------------------------------------------------------------------
void CALLBACK KeyboardProc( UINT nChar, bool bKeyDown, bool bAltDown )
{
    if( bKeyDown )
    {
        switch( nChar )
        {
            case VK_F1: g_bShowHelp = !g_bShowHelp; break;
			case 'T': g_bShowText = !g_bShowText; break;
        }
    }
}


//--------------------------------------------------------------------------------------
// OnGUIEvent
//--------------------------------------------------------------------------------------
void CALLBACK OnGUIEvent( UINT nEvent, int nControlID, CDXUTControl* pControl )
{
    CDXUTComboBox* pComboBox1 = NULL;
	CDXUTComboBox* pComboBox2 = NULL;
	CDXUTSlider* pSlider1 = NULL;
    CDXUTCheckBox* pCheckBox = NULL;             
	    
    switch( nControlID )
    {
        case IDC_TOGGLEFULLSCREEN: DXUTToggleFullScreen(); break;
        case IDC_TOGGLEREF:        DXUTToggleREF(); break;
        case IDC_CHANGEDEVICE:     DXUTSetShowSettingsDialog( !DXUTGetShowSettingsDialog() ); break;
		
		case IDC_BLOOM:            g_bBloom = !g_bBloom; break;

        case IDC_RENDER_MODE:
            pComboBox1 = (CDXUTComboBox*) pControl;  
            g_eRenderMode = (RENDER_MODE) (int) PtrToInt(pComboBox1->GetSelectedData());
            break;
		
		case IDC_CAMERA_MODE:
            pComboBox2 = (CDXUTComboBox*) pControl;  
            g_eCameraMode = (CAMERA_MODE) (int) PtrToInt(pComboBox2->GetSelectedData());
            break;
		
		case IDC_MIDDLE_GRAY:			
			pSlider1 = (CDXUTSlider*) pControl;  
			g_iMiddleGray = (int) PtrToInt(pSlider1->GetValue());
			g_fMiddleGray = ((float)g_iMiddleGray/100.0);
			WCHAR sz[100];
			_snwprintf( sz, 100, L"Middle Gray: %2.2f", g_fMiddleGray ); 
			sz[99] = 0;
			g_SampleUI.GetStatic( IDC_CHANGE_MIDDLE_GRAY_STATIC )->SetText( sz );

		case IDC_USESIMD: 
			g_bUseSIMD = !g_bUseSIMD;
			break;
    }
}


//--------------------------------------------------------------------------------------
// OnLostDevice
//--------------------------------------------------------------------------------------
void CALLBACK OnLostDevice()
{
    int i = 0;
    
    g_Skybox.InvalidateDeviceObjects();

    if( g_pFont )
        g_pFont->OnLostDevice();

    if( g_pEffect )
        g_pEffect->OnLostDevice();

    SAFE_RELEASE( g_pTexRender );
    SAFE_RELEASE( g_pTexBrightPass );
	SAFE_RELEASE( g_pLumSurf );

   

    for( i=0; i < NUM_BLOOM_TEXTURES; i++ )
    {
        SAFE_RELEASE( g_apTexBloom[i] );
    }
}


//--------------------------------------------------------------------------------------
//  OnDestroyDevice
//--------------------------------------------------------------------------------------
void CALLBACK OnDestroyDevice()
{
    g_Skybox.DeleteDeviceObjects();
    g_Skybox.Destroy();

    SAFE_RELEASE( g_pFont );
    SAFE_RELEASE( g_pEffect );
    SAFE_RELEASE( g_pMesh0 );
	SAFE_RELEASE( g_pMesh1 );
	SAFE_RELEASE( g_pMesh2 );
	SAFE_RELEASE( g_pMesh3 );

	SAFE_RELEASE( g_pTexCross_RGBE8 );
}

//--------------------------------------------------------------------------------------
//  GaussianDistribution
//--------------------------------------------------------------------------------------
inline float GaussianDistribution( float x, float y, float rho )
{
    float g = 1.0f / sqrtf( 2.0f * D3DX_PI * rho * rho );
    g *= expf( -(x*x + y*y)/(2*rho*rho) );

    return g;
}


//-----------------------------------------------------------------------------
//  RetrieveTechHandles()
//-----------------------------------------------------------------------------
HRESULT RetrieveTechHandles()
{
	CHAR* techniques[] = { "Scene", "DownScale3x3", "DownScale3x3_BrightPass", "FinalPass" };
    DWORD dwNumTechniques = sizeof(TECH_HANDLES)/sizeof(D3DXHANDLE);
    
    CHAR strBuffer[MAX_PATH] = {0};

    D3DXHANDLE* pHandle = (D3DXHANDLE*) &g_aTechHandles;

    for( UINT t=0; t < dwNumTechniques; t++ )
    {
        _snprintf( strBuffer, MAX_PATH-1, "%s", techniques[t] );

        *pHandle++ = g_pEffect->GetTechniqueByName( strBuffer );
    }
    return S_OK;
}


//-----------------------------------------------------------------------------
//  GetSampleOffsets_DownScale3x3
//-----------------------------------------------------------------------------
HRESULT GetSampleOffsets_DownScale3x3( DWORD dwWidth, DWORD dwHeight, D3DXVECTOR2 avSampleOffsets[] )
{
    if( NULL == avSampleOffsets )
        return E_INVALIDARG;

    float tU = 1.0f / dwWidth;
    float tV = 1.0f / dwHeight;

    // Sample from the 9 surrounding points. 
    int index=0;
    for( int y=-1; y <= 1; y++ )
    {
        for( int x=-1; x <= 1; x++ )
        {
            avSampleOffsets[ index ].x = x * tU;
            avSampleOffsets[ index ].y = y * tV;

            index++;
        }
    }

    return S_OK;
}


//-----------------------------------------------------------------------------
//  GetSampleOffsets_Bloom()
//-----------------------------------------------------------------------------
HRESULT GetSampleOffsets_Bloom(DWORD dwD3DTexSize,
										        float afTexCoordOffset[15],
										        D3DXVECTOR4* avColorWeight,
 										        float fDeviation, float fMultiplier )
{
    int i=0;
    float tu = 1.0f / (float)dwD3DTexSize;

    // Fill the center texel
    float weight = 1.0f * GaussianDistribution( 0, 0, fDeviation );
    avColorWeight[0] = D3DXVECTOR4( weight, weight, weight, 1.0f );

    afTexCoordOffset[0] = 0.0f;
    
    // Fill the right side
    for( i=1; i < 8; i++ )
    {
        weight = fMultiplier * GaussianDistribution( (float)i, 0, fDeviation );
        afTexCoordOffset[i] = i * tu;

        avColorWeight[i] = D3DXVECTOR4( weight, weight, weight, 1.0f );
    }

    // Copy to the left side
    for( i=8; i < 15; i++ )
    {
        avColorWeight[i] = avColorWeight[i-7];
        afTexCoordOffset[i] = -afTexCoordOffset[i-7];
    }

    return S_OK;
}

//-----------------------------------------------------------------------------
//  RenderModels()
//-----------------------------------------------------------------------------
HRESULT RenderModels(double fTime)
{
    HRESULT hr = S_OK;

	D3DXVECTOR3 blue(0.0, 0.0, 0.5);
	D3DXVECTOR3 red(0.5, 0.0, 0.0);
	D3DXVECTOR3 green(0.0, 0.5, 0.0);
	D3DXVECTOR3 yellow(0.5, 0.5, 0.0);

	float x = -cos(fTime*BALL_SPEED);
	float y = cos(fTime*BALL_SPEED);
	float z = sin(fTime*BALL_SPEED);

	// Move, transform, and draw the first mesh
	D3DXMATRIXA16 mPos0;
	D3DXMatrixTranslation( &mPos0, x, y, z );
	D3DXMatrixMultiply( &mPos0, &mPos0, g_Camera.GetWorldMatrix() );

    D3DXMATRIXA16 mWorldViewProj;
	D3DXMatrixMultiply( &mWorldViewProj, &mPos0, g_Camera.GetViewMatrix() );
    D3DXMatrixMultiply( &mWorldViewProj, &mWorldViewProj, g_Camera.GetProjMatrix() );

    g_pEffect->SetMatrix( "g_mWorld", g_Camera.GetWorldMatrix() );
    g_pEffect->SetMatrix( "g_mWorldViewProj", &mWorldViewProj );

    g_pEffect->SetTechnique( g_pCurTechnique->Scene );
	g_pEffect->SetValue("model_color", blue, sizeof(D3DXVECTOR3));
    g_pEffect->SetTexture( "g_tCube", g_Skybox.GetEnvMap() );

    UINT uiPass, uiNumPasses;
    V_RETURN( g_pEffect->Begin( &uiNumPasses, 0 ) );

    for( uiPass=0; uiPass < uiNumPasses; uiPass++ )
    {
        g_pEffect->BeginPass( uiPass );

        g_pMesh0->DrawSubset(0);

        g_pEffect->EndPass();
    }

    g_pEffect->End();

	
	x = cos(fTime*BALL_SPEED - 1000);
	y = cos(fTime*BALL_SPEED - 1000);
	z = -sin(fTime*BALL_SPEED - 1000);

	D3DXMATRIXA16 mPos1;
	D3DXMatrixTranslation( &mPos1, x, y, z );
	D3DXMatrixMultiply( &mPos1, &mPos1, g_Camera.GetWorldMatrix() );

	D3DXMatrixMultiply( &mWorldViewProj, &mPos1, g_Camera.GetViewMatrix() );
    D3DXMatrixMultiply( &mWorldViewProj, &mWorldViewProj, g_Camera.GetProjMatrix() );
    g_pEffect->SetMatrix( "g_mWorld", g_Camera.GetWorldMatrix() );
    g_pEffect->SetMatrix( "g_mWorldViewProj", &mWorldViewProj );

	g_pEffect->SetTechnique( g_pCurTechnique->Scene );
	g_pEffect->SetValue("model_color", red, sizeof(D3DXVECTOR3));
    g_pEffect->SetTexture( "g_tCube", g_Skybox.GetEnvMap() );

    V_RETURN( g_pEffect->Begin( &uiNumPasses, 0 ) );

    for( uiPass=0; uiPass < uiNumPasses; uiPass++ )
    {
        g_pEffect->BeginPass( uiPass );

        g_pMesh1->DrawSubset(0);

        g_pEffect->EndPass();
    }

    g_pEffect->End();

	x = 0;
	y = cos(fTime*BALL_SPEED - 750);
	z = sin(fTime*BALL_SPEED - 750);

	D3DXMATRIXA16 mPos2;
	D3DXMatrixTranslation( &mPos2, x, y, z );
	D3DXMatrixMultiply( &mPos2, &mPos2, g_Camera.GetWorldMatrix() );

	D3DXMatrixMultiply( &mWorldViewProj, &mPos2, g_Camera.GetViewMatrix() );
    D3DXMatrixMultiply( &mWorldViewProj, &mWorldViewProj, g_Camera.GetProjMatrix() );
    g_pEffect->SetMatrix( "g_mWorld", g_Camera.GetWorldMatrix() );
    g_pEffect->SetMatrix( "g_mWorldViewProj", &mWorldViewProj );

	g_pEffect->SetTechnique( g_pCurTechnique->Scene );
	g_pEffect->SetValue("model_color", green, sizeof(D3DXVECTOR3));
    g_pEffect->SetTexture( "g_tCube", g_Skybox.GetEnvMap() );

    V_RETURN( g_pEffect->Begin( &uiNumPasses, 0 ) );

    for( uiPass=0; uiPass < uiNumPasses; uiPass++ )
    {
        g_pEffect->BeginPass( uiPass );

        g_pMesh2->DrawSubset(0);

        g_pEffect->EndPass();
    }

    g_pEffect->End();

	x = sin(fTime*BALL_SPEED - 750);
	y = 0;
	z = -sin(fTime*BALL_SPEED - 750);

	D3DXMATRIXA16 mPos3;
	D3DXMatrixTranslation( &mPos3, x, y, z );
	D3DXMatrixMultiply( &mPos3, &mPos3, g_Camera.GetWorldMatrix() );

	D3DXMatrixMultiply( &mWorldViewProj, &mPos3, g_Camera.GetViewMatrix() );
    D3DXMatrixMultiply( &mWorldViewProj, &mWorldViewProj, g_Camera.GetProjMatrix() );
    g_pEffect->SetMatrix( "g_mWorld", g_Camera.GetWorldMatrix() );
    g_pEffect->SetMatrix( "g_mWorldViewProj", &mWorldViewProj );

	g_pEffect->SetTechnique( g_pCurTechnique->Scene );
	g_pEffect->SetValue("model_color", yellow, sizeof(D3DXVECTOR3));
    g_pEffect->SetTexture( "g_tCube", g_Skybox.GetEnvMap() );

    V_RETURN( g_pEffect->Begin( &uiNumPasses, 0 ) );

    for( uiPass=0; uiPass < uiNumPasses; uiPass++ )
    {
        g_pEffect->BeginPass( uiPass );

        g_pMesh3->DrawSubset(0);

        g_pEffect->EndPass();
    }

    g_pEffect->End();

    return S_OK;
}

//-----------------------------------------------------------------------------
//  RenderSkybox()
//-----------------------------------------------------------------------------
HRESULT RenderSkybox()
{
    HRESULT hr = S_OK;

    // Update matrices
    D3DXMATRIXA16 mWorld;
    D3DXMATRIXA16 mWorldView;
    D3DXMATRIXA16 mWorldViewProj;

    D3DXMatrixMultiply( &mWorldViewProj, g_Camera.GetViewMatrix(), g_Camera.GetProjMatrix() );
    g_pEffect->SetMatrix( "g_mWorldViewProj", &mWorldViewProj );


    // Draw the skybox
    UINT uiPass, uiNumPasses;
    g_pEffect->SetTechnique( "Skybox" );
    V_RETURN( g_pEffect->Begin( &uiNumPasses, 0 ) );
    
    for( uiPass=0; uiPass < uiNumPasses; uiPass++ )
    {
        g_pEffect->BeginPass( uiPass );

        g_Skybox.Render();

        g_pEffect->EndPass();
    }

    g_pEffect->End();

    return S_OK;
}

//-----------------------------------------------------------------------------
// BrightPassFilter
//-----------------------------------------------------------------------------
HRESULT BrightPassFilter()
{
    HRESULT hr = S_OK;

    const D3DSURFACE_DESC* pBackBufDesc = DXUTGetBackBufferSurfaceDesc();
    
    D3DXVECTOR2 avSampleOffsets[16];
    GetSampleOffsets_DownScale3x3( pBackBufDesc->Width/2, pBackBufDesc->Height/2, avSampleOffsets );

    g_pEffect->SetValue("g_avSampleOffsets", avSampleOffsets, sizeof(avSampleOffsets));
	g_pEffect->SetValue("g_fMiddleGray", &g_fMiddleGray, sizeof(float));
	g_pEffect->SetValue("g_fImageKey", &g_fImageKey, sizeof(FLOAT));

    LPDIRECT3DSURFACE9 pSurfBrightPass = NULL;
    hr = g_pTexBrightPass->GetSurfaceLevel( 0, &pSurfBrightPass );
    if( FAILED(hr) )
        return hr;

    g_pEffect->SetTechnique( g_pCurTechnique->DownScale3x3_BrightPass );
    g_pd3dDevice->SetRenderTarget(0, pSurfBrightPass);
    g_pd3dDevice->SetTexture(0, g_pTexRender);


    g_pd3dDevice->SetSamplerState( 0, D3DSAMP_MINFILTER, D3DTEXF_POINT );

    UINT uiPass, uiNumPasses;
    hr = g_pEffect->Begin(&uiNumPasses, 0);
    if( FAILED(hr) )
        return hr;

    for (uiPass = 0; uiPass < uiNumPasses; uiPass++)
    {
        g_pEffect->BeginPass(uiPass);

        // Draw a fullscreen quad to sample the RT
        DrawFullScreenQuad();

        g_pEffect->EndPass();
    }

    g_pEffect->End();
    g_pd3dDevice->SetTexture( 0, NULL );
    g_pd3dDevice->SetTexture( 1, NULL );

    SAFE_RELEASE( pSurfBrightPass );

    return S_OK;
}


//-----------------------------------------------------------------------------
// RenderBloom()
//-----------------------------------------------------------------------------
HRESULT RenderBloom()
{
    HRESULT hr = S_OK;
    UINT uiPassCount, uiPass;
    int i=0;

    D3DXVECTOR2 avSampleOffsets[16];
    float       afSampleOffsets[16];
    D3DXVECTOR4 avSampleWeights[16];

    LPDIRECT3DSURFACE9 pSurfDest = NULL;
    hr = g_apTexBloom[1]->GetSurfaceLevel( 0, &pSurfDest );
    if( FAILED(hr) )
        return hr;
    
    D3DSURFACE_DESC desc;
    hr = g_pTexBrightPass->GetLevelDesc( 0, &desc );
    if( FAILED(hr) )
        return hr;

    hr = GetSampleOffsets_Bloom( desc.Width, afSampleOffsets, avSampleWeights, 3.0f, 1.25f );
    for( i=0; i < 16; i++ )
    {
        avSampleOffsets[i] = D3DXVECTOR2( afSampleOffsets[i], 0.0f );
    }
     
    g_pEffect->SetTechnique("Bloom");
    g_pEffect->SetValue("g_avSampleOffsets", avSampleOffsets, sizeof(avSampleOffsets));
    g_pEffect->SetValue("g_avSampleWeights", avSampleWeights, sizeof(avSampleWeights));
   
    g_pd3dDevice->SetRenderTarget(0, pSurfDest);
    g_pd3dDevice->SetTexture( 0, g_pTexBrightPass );
    g_pd3dDevice->SetSamplerState( 0, D3DSAMP_MINFILTER, D3DTEXF_POINT );
    g_pd3dDevice->SetSamplerState( 0, D3DSAMP_MAGFILTER, D3DTEXF_POINT );
       
    
    g_pEffect->Begin(&uiPassCount, 0);
    for (uiPass = 0; uiPass < uiPassCount; uiPass++)
    {
        g_pEffect->BeginPass(uiPass);

        // Draw a fullscreen quad to sample the RT
        DrawFullScreenQuad();

        g_pEffect->EndPass();
    }
    g_pEffect->End();
    g_pd3dDevice->SetTexture( 0, NULL );
    
    SAFE_RELEASE( pSurfDest );
    hr = g_apTexBloom[0]->GetSurfaceLevel( 0, &pSurfDest );
    if( FAILED(hr) )
        return hr;

    hr = GetSampleOffsets_Bloom( desc.Height, afSampleOffsets, avSampleWeights, 3.0f, 1.25f );
    for( i=0; i < 16; i++ )
    {
        avSampleOffsets[i] = D3DXVECTOR2( 0.0f, afSampleOffsets[i] );
    }

    g_pEffect->SetTechnique("Bloom");
    g_pEffect->SetValue("g_avSampleOffsets", avSampleOffsets, sizeof(avSampleOffsets));
    g_pEffect->SetValue("g_avSampleWeights", avSampleWeights, sizeof(avSampleWeights));
    
    g_pd3dDevice->SetRenderTarget(0, pSurfDest);
    g_pd3dDevice->SetTexture(0, g_apTexBloom[1]);
    g_pd3dDevice->SetSamplerState( 0, D3DSAMP_MINFILTER, D3DTEXF_POINT );
    g_pd3dDevice->SetSamplerState( 0, D3DSAMP_MAGFILTER, D3DTEXF_POINT );
       
   
    g_pEffect->Begin(&uiPassCount, 0);

    for (uiPass = 0; uiPass < uiPassCount; uiPass++)
    {
        g_pEffect->BeginPass(uiPass);

        // Draw a fullscreen quad to sample the RT
        DrawFullScreenQuad();

        g_pEffect->EndPass();
    }

    g_pEffect->End();
    g_pd3dDevice->SetTexture( 0, NULL );
   
    SAFE_RELEASE( pSurfDest );
  
    return hr;
}


//-----------------------------------------------------------------------------
// DrawFullScreenQuad
//-----------------------------------------------------------------------------
void DrawFullScreenQuad(float fLeftU, float fTopV, float fRightU, float fBottomV)
{
    D3DSURFACE_DESC dtdsdRT;
    PDIRECT3DSURFACE9 pSurfRT;

    // Acquire render target width and height
    g_pd3dDevice->GetRenderTarget(0, &pSurfRT);
    pSurfRT->GetDesc(&dtdsdRT);
    pSurfRT->Release();

    // Ensure that we're directly mapping texels to pixels by offset by 0.5
    // For more info see the doc page titled "Directly Mapping Texels to Pixels"
    FLOAT fWidth5 = (FLOAT)dtdsdRT.Width - 0.5f;
    FLOAT fHeight5 = (FLOAT)dtdsdRT.Height - 0.5f;

    // Draw the quad
    SCREEN_VERTEX svQuad[4];

    svQuad[0].pos = D3DXVECTOR4(-0.5f, -0.5f, 0.5f, 1.0f);
    svQuad[0].tex = D3DXVECTOR2(fLeftU, fTopV);

    svQuad[1].pos = D3DXVECTOR4(fWidth5, -0.5f, 0.5f, 1.0f);
    svQuad[1].tex = D3DXVECTOR2(fRightU, fTopV);

    svQuad[2].pos = D3DXVECTOR4(-0.5f, fHeight5, 0.5f, 1.0f);
    svQuad[2].tex = D3DXVECTOR2(fLeftU, fBottomV);

    svQuad[3].pos = D3DXVECTOR4(fWidth5, fHeight5, 0.5f, 1.0f);
    svQuad[3].tex = D3DXVECTOR2(fRightU, fBottomV);

    g_pd3dDevice->SetRenderState(D3DRS_ZENABLE, FALSE);
    g_pd3dDevice->SetFVF(SCREEN_VERTEX::FVF);
    g_pd3dDevice->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP, 2, svQuad, sizeof(SCREEN_VERTEX));
    g_pd3dDevice->SetRenderState(D3DRS_ZENABLE, TRUE);
}
