//--------------------------------------------------------------------------------------
// File: SIMD.h
//--------------------------------------------------------------------------------------

#include "dxstdafx.h"
#include "timer.h"
#include "emmintrin.h"


#define SIMD_RGBE_CONVERT

//static SIMD operators
static __declspec(align(16)) __m128   one_128 = _mm_set1_ps ( (float)1.0 );
static __declspec(align(16)) __m128   zero_128 = _mm_setzero_ps ();
static __declspec(align(16)) __m128   twofiftyfive_128 = _mm_set1_ps ( 255.0 );
static __declspec(align(16)) __m128   oneover255_128 = _mm_set1_ps ( 1.0/255.0 );
static __declspec(align(16)) __m128   point2125_128 = _mm_set1_ps ( 0.2125 );
static __declspec(align(16)) __m128   point7154_128 = _mm_set1_ps ( 0.7154 );
static __declspec(align(16)) __m128   point0721_128 = _mm_set1_ps ( 0.0721 );
static __declspec(align(16)) __m128   point001_128 = _mm_set1_ps ( 0.001 );
static __declspec(align(16)) __m128i  zero_128i = _mm_setzero_si128();
static __declspec(align(16)) __m128i  one_128i = _mm_set1_epi32 ( 0x1 );
static __declspec(align(16)) __m128i  oo7ffff_128i = _mm_set1_epi32 ( 0x007ffff );
static __declspec(align(16)) __m128i  onetwentyseven_128i = _mm_set1_epi32 ( 127 );
static __declspec(align(16)) __m128i  onetwentyeight_128i = _mm_set1_epi32 ( 128 );

//m128 union so we can use float bits explicitly
__declspec(align(16)) union U_128 {
	__m128i i;
	__m128  f;
};

HRESULT CreateRGBETextureFromRLEFile( IDirect3DDevice9* pd3dDevice, LPDIRECT3DTEXTURE9* ppTexDest_RGBE8, char* strHDRFile );

HRESULT MeasureLuminance(IDirect3DDevice9* pd3dDevice, LPDIRECT3DSURFACE9 pSourceRenderTarget, LPDIRECT3DSURFACE9 g_pLumSurf, bool g_bUseSIMD); 